MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes
sc::QNewtonOpt Class Reference

The QNewtonOpt implements a quasi-Newton optimization scheme. More...

`#include <qnewton.h>`

Inheritance diagram for sc::QNewtonOpt:

List of all members.

## Public Member Functions

| QNewtonOpt (const Ref< KeyVal > &)
| The KeyVal constructor.
| QNewtonOpt (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
void | apply_transform (const Ref< NonlinearTransform > &)
void | init ()
| Initialize the optimizer.
int | update ()
| Take a step.

## Protected Attributes

double | maxabs_gradient
double | accuracy_
RefSymmSCMatrix | ihessian_
Ref< HessianUpdate > | update_
Ref< LineOpt > | lineopt_
int | take_newton_step_
int | print_hessian_
int | print_x_
int | print_gradient_
int | linear_
int | restrict_
int | dynamic_grad_acc_
int | force_search_
int | restart_

## Detailed Description

The QNewtonOpt implements a quasi-Newton optimization scheme.

## Constructor & Destructor Documentation

sc::QNewtonOpt::QNewtonOpt | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor.

The KeyVal constructor reads the following keywords:

`update`

  This gives a HessianUpdate object. The default is to not update the hessian.

`hessian`

  By default, the guess hessian is obtained from the Function object. This keyword specifies an lower triangle array (the second index must be less than or equal to than the first) that replaces the guess hessian. If some of the elements are not given, elements from the guess hessian will be used.

`lineopt`

  This gives a LineOpt object for doing line optimizations in the Newton direction. The default is to skip the line optimizations.

`accuracy`

  The accuracy with which the first gradient will be computed. If this is too large, it may be necessary to evaluate the first gradient point twice. If it is too small, it may take longer to evaluate the first point. The default is 0.0001.

`print_x`

  If true, print the coordinates each iteration. The default is false.

`print_gradient`

  If true, print the gradient each iteration. The default is false.

`print_hessian`

  If true, print the approximate hessian each iteration. The default is false.

`restrict`

  Use step size restriction when not using a line search. The default is true.

## Member Function Documentation

void sc::QNewtonOpt::save_data_state | ( | StateOut & |  | ) | `[virtual]`

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::Optimize.

int sc::QNewtonOpt::update | ( |  | ) | `[virtual]`

Take a step.

Returns 1 if the optimization has converged, otherwise 0.

Implements sc::Optimize.

The documentation for this class was generated from the following file:

- qnewton.h